CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


OBJ

  v     : "VocalTract"

  
VAR

  byte  aa,ga,gp,vp,vr,f1,f2,f3,f4,na,nf,fa,ff  'vocal tract parameters
  

PUB start

  v.start(@aa, 10, 11, -1)              'start tract, output to pins 10,11
 
  repeat                                'keep repeating talk
    gp := rnd(50, 100)                  'set random glottal pitch
    vp := rnd(4, 24)                    'set random vibrato pitch
    vr := rnd(4, 10)                    'set random vibrato rate
    talk                                'talk


PRI talk

  setformants(0, 1350, 1350, 4700)      'set formants for G/C before R
  v.go(1)

  aa := 20                              'set breathiness
  v.go(25)                              'make brief G/C turbulence

  setformants(580, 1200, 1500, 4700)    'set formants for R
  ga := 30                              'voice up for G / skip for C
  v.go(150)                             'transition to R

  ga := 30                              'sustain / voice up for C
  v.go(100)                             'sustain / voice up for C
  v.go(200)                             'sustain

  setformants(560, 850, 2600, 3600)     'set formants for L
  v.go(250)                             'transition
  v.go(100)                             'sustain

  aa := 0                               'taper down to silence
  ga := 0
  v.go(100)

  v.go(500)                             'pause


PRI setformants(s1, s2, s3, s4)

  f1 := s1 * 100 / 1953
  f2 := s2 * 100 / 1953
  f3 := s3 * 100 / 1953
  f4 := s4 * 100 / 1953


PRI rnd(low, high)

  return low + ||(?cnt // (high - low + 1))
